<?php
/*
  MailBeez Automatic Trigger Email Campaigns
  http://www.mailbeez.com

  Copyright (c) 2010 MailBeez
	
	inspired and in parts based on
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

	// make path work from admin
  require_once(DIR_FS_CATALOG. 'mailhive/common/classes/mailbeez.php');	
	
	// could be in language-file
	// just easier to define it in the mailbee
	define('MAILBEEZ_NOPURCHASE_TEXT_TITLE', 'Contact Customers without Purchase');
	
	
	define('MAILBEEZ_NOPURCHASE_TEXT_DESCRIPTION', 'Contact customers with account but no orders.<br>
	<br>');
	
  class nopurchase extends mailbeez {
		// class constructor
    function nopurchase() {
			// call constructor
			mailbeez::mailbeez(); 
			
			// set some stuff:
      $this->code = 'nopurchase';
			$this->module = 'nopurchase'; // same as folder name
			$this->version = '1.0'; // float value
			$this->iteration = 1;
      $this->title = MAILBEEZ_NOPURCHASE_TEXT_TITLE;
      $this->description = MAILBEEZ_NOPURCHASE_TEXT_DESCRIPTION;
      $this->sort_order = MAILBEEZ_NOPURCHASE_SORT_ORDER;
      $this->enabled = ((MAILBEEZ_NOPURCHASE_STATUS == 'True') ? true : false);
			$this->sender = MAILBEEZ_NOPURCHASE_SENDER;
			$this->sender_name = MAILBEEZ_NOPURCHASE_SENDER_NAME;
			$this->status_key = 'MAILBEEZ_NOPURCHASE_STATUS';
			
			//$this->icon = 'icon.png';
			
			$this->documentation_key = $this->module; // leave empty if no documentation available
			// $this->documentation_root = 'http:://yoursite.com/' // modify documentation root if necessary
			
			$this->htmlBodyTemplateResource = 'body_html.tpl'; // located in folder of this module
			$this->txtBodyTemplateResource = 'body_txt.tpl'; // located in folder of this module			
			$this->subjectTemplateResource = 'subject.tpl'; // located in folder of this module
			
			$this->audience = array();
			$this->additionalFields = array('customers_id' => '007', 'customers_email_address' => 'customer@mail.com', 'storename' => STORE_NAME, 'storeurl' => mh_href_link(FILENAME_DEFAULT)); 
			// list of additional fields to show in listing with testvalues used for Test-Mail
	
    }

// class methods
    
		function getAudience() {
			global $languages_id;
			$status = MAILBEEZ_NOPURCHASE_ORDER_STATUS_ID;
			
			// MAILBEEZ_NOPURCHASE_PASSED_DAYS
			// MAILBEEZ_NOPURCHASE_PASSED_DAYS_SKIP
			
      $date_skip = $this->dbdate(MAILBEEZ_NOPURCHASE_PASSED_DAYS_SKIP);
      $date_passed = $this->dbdate(MAILBEEZ_NOPURCHASE_PASSED_DAYS);
			
      $query_raw = "select c.customers_firstname, c.customers_lastname, 
														c.customers_id, c.customers_email_address
											      from " . TABLE_CUSTOMERS. " c, " . TABLE_CUSTOMERS_INFO . " ci
											        left join " . TABLE_ORDERS . " o
											          on (o.customers_id = ci.customers_info_id) " . 
														  ( (MAILBEEZ_NOPURCHASE_CB == 'True') ? 
														  " left join  " . TABLE_CUSTOMERS_BASKET . " cb
											          on (cb.customers_id = ci.customers_info_id) " : '' ) . "
											      where o.customers_id is NULL  " .
															( (MAILBEEZ_NOPURCHASE_CB == 'True') ? 
															" and cb.customers_id is NULL  " : '' ) . "
															and ci.customers_info_id = c.customers_id
											        and ci.customers_info_date_account_created <= '" . $date_passed . "' 
											        and ci.customers_info_date_account_created > '" . $date_skip . "' ";		
			
			//echo  $query_raw;
			
			$query = mh_db_query($query_raw);
			
			// for early check
			$mb_chk = new mailbeez_mailer($this);			
			
			while ($item = mh_db_fetch_array($query)) {
			// mandatory fields:
			// - firstname
			// - lastname
			// - email_address
			// - customers-id -> block
			
			// other keys are replaced while sending: $<key>
			
				// early check to avoid processing when email was already sent
				$chk_result = $mb_chk->check($this->module, $this->iteration, $item['customers_id']);
				if ($chk_result != false) {
					// this iteration for this customer was already sent -> skip
					continue;
				}			
			
			
				$this->audience[$item['customers_id']] = array('firstname' => $item['customers_firstname'],
																											 'lastname' => $item['customers_lastname'],
			                                                 'email_address' => $item['customers_email_address'],
																											 'customers_id' => $item['customers_id'],
																											 'storename' => STORE_NAME,
																											 'storeurl' => mh_href_link(FILENAME_DEFAULT)
																								 );
			}
			return $this->audience;
		}
		
		
		
		// installation methods
		
    function keys() {
      return array('MAILBEEZ_NOPURCHASE_STATUS', 'MAILBEEZ_NOPURCHASE_PASSED_DAYS', 'MAILBEEZ_NOPURCHASE_PASSED_DAYS_SKIP', 'MAILBEEZ_NOPURCHASE_SENDER', 'MAILBEEZ_NOPURCHASE_CB', 'MAILBEEZ_NOPURCHASE_SENDER_NAME', 'MAILBEEZ_NOPURCHASE_SORT_ORDER');
    }
		
    function install() {
			mh_insert_config_value(array('configuration_title' => 'Send nopurchase email', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_STATUS', 
																	 'configuration_value' => 'False', 
																	 'configuration_description' => 'Do you want to send nopurchase emails?', 
																	 'set_function' => 'mh_cfg_select_option(array(\'True\', \'False\'), '
																	 ));

			mh_insert_config_value(array('configuration_title' => 'Set days passed after account created', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_PASSED_DAYS', 
																	 'configuration_value' => '5', 
																	 'configuration_description' => 'number of days since customer signed for an account', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'Set days to skip after', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_PASSED_DAYS_SKIP', 
																	 'configuration_value' => '10', 
																	 'configuration_description' => 'number of days after which do skip the nopurchase email', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'check for empty customer basket', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_CB', 
																	 'configuration_value' => 'False', 
																	 'configuration_description' => 'send only when customer basket is empty?', 
																	 'set_function' => 'mh_cfg_select_option(array(\'True\', \'False\'), '
																	 ));																	 
																	 
			mh_insert_config_value(array('configuration_title' => 'sender email', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_SENDER', 
																	 'configuration_value' => STORE_OWNER_EMAIL_ADDRESS, 
																	 'configuration_description' => 'sender email', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'sender name', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_SENDER_NAME', 
																	 'configuration_value' => STORE_NAME, 
																	 'configuration_description' => 'sender email', 
																	 'set_function' => ''
																	 ));
																	 																	 
			mh_insert_config_value(array('configuration_title' => 'Sort order of display.', 
																	 'configuration_key' => 'MAILBEEZ_NOPURCHASE_SORT_ORDER', 
																	 'configuration_value' => '50', 
																	 'configuration_description' => 'Sort order of display. Lowest is displayed first.', 
																	 'set_function' => ''
																	 ));
    }		
  }
?>
